/* 
Author: Yingying Sang
Date: 02Aug2011
Formula used: Pencina; Statist.Med.2011,30:11-21
*/
program NRIsurv, eclass
version 11
syntax varlist(min=2 max=2) [if] [in],riskcut(numlist) [ftime(real 999)] //varlist=p_old, p_new
marksample touse
tempvar p_old p_new up down oldcat newcat upcat downcat s s_upc s_up s_downc s_down
tempname b
local colnames "nri_cat nri_cat_evt nri_cat_nev nri_con nri_con_evt nri_con_nev"
qui count if _d==1 & `touse' & _t<=`ftime'
if _N==0 {
   matrix `b'=(999,999,999,999,999,999)
   matrix colnames `b'=`colnames'
   return matrix nri=`b'
   exit
   }
tokenize `varlist'
gen `p_old'=`1'
gen `p_new'=`2'
qui gen `up'=(`p_new'>`p_old') if `touse'
qui gen `down'=(`p_new'<`p_old') if `touse'
qui egen `oldcat'=cut(`p_old') if `touse', at(0 `riskcut' 1.01) label
qui egen `newcat'=cut(`p_new') if `touse', at(0 `riskcut' 1.01) label
qui gen `upcat'=(`newcat'>`oldcat') if `touse'
qui gen `downcat'=(`newcat'<`oldcat') if `touse'
qui count if `touse'==1
local tot=r(N)
qui sts generate `s'=s if `touse'
qui count if `upcat'==1 & `touse'==1
local totupc=r(N)
if `totupc'>0 sts generate `s_upc'=s if `upcat'==1 & `touse'==1
qui count if `downcat'==1 & `touse'==1
local totdownc=r(N)
if `totdownc'>0 sts generate `s_downc'=s if `downcat'==1 & `touse'==1
qui count if `up'==1 & `touse'==1
local totup=r(N)
if `totup'>0 sts generate `s_up'=s if `up'==1 & `touse'==1
qui count if `down'==1 & `touse'==1
local totdown=r(N)
if `totdown'>0 sts generate `s_down'=s if `down'==1 & `touse'==1
qui sum `s' if _t<=`ftime' & `touse'==1
if r(min)<1 & r(min)>0 local s1=r(min)
else local s1=999
capture sum `s_upc' if _t<=`ftime' & `touse'==1
if _rc==0 & r(min)<1 & r(min)>0 local supc=r(min)
else {
   local supc=999
   local totupc=0
   }
capture sum `s_downc' if _t<=`ftime' & `touse'==1
if _rc==0 & r(min)<1 & r(min)>0 local sdownc=r(min)
else {
   local sdownc=999
   local totdownc=0
   }
capture sum `s_up' if _t<=`ftime' & `touse'==1
if _rc==0 & r(min)<1 & r(min)>0 local sup=r(min)
else {
   local sup=999
   local totup=0
   }
capture sum `s_down' if _t<=`ftime' & `touse'==1
if _rc==0 & r(min)<1 & r(min)>0 local sdown=r(min)
else {
   local sdown=999
   local totdown=0
   }
if `supc'==999 & `sdownc'==999 | `s1'==999 {
   local nricat=999
   local nricatevt=999
   local nricatnev=999
   }
else {
   local nricat=((1-`supc')*`totupc'-(1-`sdownc')*`totdownc')/(`tot'*(1-`s1'))-(`supc'*`totupc'-`sdownc'*`totdownc')/(`tot'*`s1')
   local nricatevt=((1-`supc')*`totupc'-(1-`sdownc')*`totdownc')/(`tot'*(1-`s1'))
   local nricatnev=(`sdownc'*`totdownc'-`supc'*`totupc')/(`tot'*`s1')
   }
if `sup'==999 & `sdown'==999 | `s1'==999 {
   local nricon=999
   local nriconevt=999
   local nriconnev=999
   }
else {
   local nricon=((1-`sup')*`totup'-(1-`sdown')*`totdown')/(`tot'*(1-`s1'))-(`sup'*`totup'-`sdown'*`totdown')/(`tot'*`s1')
   local nriconevt=((1-`sup')*`totup'-(1-`sdown')*`totdown')/(`tot'*(1-`s1'))
   local nriconnev=(`sdown'*`totdown'-`sup'*`totup')/(`tot'*`s1')
   }
matrix `b'=(`nricat',`nricatevt',`nricatnev',`nricon',`nriconevt',`nriconnev')
matrix colnames `b'=`colnames'
ereturn post `b', esample(`touse')
end
